//////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2016 Leszek Koltunski                                                          //
//                                                                                          //
// This file is part of Distorted.                                                          //
//                                                                                          //
// Distorted is free software: you can redistribute it and/or modify                        //
// it under the terms of the GNU General Public License as published by                     //
// the Free Software Foundation, either version 2 of the License, or                        //
// (at your option) any later version.                                                      //
//                                                                                          //
// Distorted is distributed in the hope that it will be useful,                             //
// but WITHOUT ANY WARRANTY; without even the implied warranty of                           //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            //
// GNU General Public License for more details.                                             //
//                                                                                          //
// You should have received a copy of the GNU General Public License                        //
// along with Distorted.  If not, see <http://www.gnu.org/licenses/>.                       //
//////////////////////////////////////////////////////////////////////////////////////////////

precision lowp float;

varying vec2 v_TexCoordinate;
uniform sampler2D u_Texture;
uniform vec2 one_over_objD;
uniform float u_Radius;

//////////////////////////////////////////////////////////////////////////////////////////////

void main()
  {
  vec2 tex;
  vec4 pixel = vec4(0.0);
  float denom = 1.0 / ((2.0*u_Radius+1.0)*(2.0*u_Radius+1.0));

  for (float x = -u_Radius; x <= u_Radius; x+=1.0)
    for (float y = -u_Radius; y <= u_Radius; y+=1.0)
      {
      tex = vec2(v_TexCoordinate.x + x*one_over_objD.x, v_TexCoordinate.y + y*one_over_objD.y);
      pixel += texture2D(u_Texture,tex)*denom;
      }

  gl_FragColor = pixel;
  }